      
      subroutine rkfWARN(neqn,u,s,iflin,relerr,abserr,iflout)
      implicit real*8 (a-h,o-z)
c     summarizes WARNING/ERROR messages of /rkf45 for
c     iflag (iflin) values +3 to +8.

c     subr/rkfWARN   status :         27 March 1990

c       J. G. Dworski

c       H a n d l i n g
c       ===============

c     INPUT:
c       neqn    = # of differential equations
c       s       = integration argument
c       y(i)    = neqn-vector of dependent variables
c       iflin   = iflag value on input (+3 to +8)
c     INPUT/OUTPUT:
c       relerr  = (chgd only by iflag=6) relative error
c       abserr  = (chgd only by iflag=5) absolute error
c     OUTPUT:
c       iflout  = iflag value on output (if +9, then terminate job)

c     ------------------------------------------------------------
c     changes:
c       changed "double precision" to "real*8"  (craig friesen 7/8/92)
c       output channeled to standard error      (craig friesen 7/8/92)
c     ------------------------------------------------------------

      real*8  u(neqn)
c      logical  yes

  501 format(/)

c      write (0,501)
      iflag = iflin

      if     (iflin.eq.3) then
       write (0,*)' CAUTION: iflag=+3 : ',iflag
       write (0,*)' /relerr/ was specified too small; it was internally'
c       write (0,*)' increased and /rkf45/ is ready for (user initiated)'
c       write (0,*)' continuation :'
c                       no longer 'interactive' so it'll do it by itself crf
       write (0,*)' increased and /rkf45/ is ready for continuation :'
       write (0,*)' relerr = ',relerr
       write (0,*)' abserr = ',abserr
       iflout = iflin

      elseif (iflin.eq.4) then
       write (0,*)' ATTENTION: iflag=+4 : ',iflag
       write (0,*)' more than  4000  derivative evaluations were'
       write (0,*)' requested so far without an output; '
       write (0,*)' TOO LONG INTERVAL OF SILENT INTEGRATION'
       iflout = iflin

      elseif (iflin.eq.5) then
       write (0,*)' WARNING: iflag=+5 : ',iflag
       write (0,*)' solution  v a n i s h e d,  making'
       write (0,*)' a   p u r e l y  relative error test impossible;'
       write (0,*)' use non-zero /abserr/ specification to continue'
       write (0,*)' (or proceed by single-step-integration)'
       abserr = abserr + 1.5d-7
       write (0,*)' newly proposed ABSOLUTE ERROR : ',abserr
       iflout = iflin

      elseif (iflin.eq.6) then
       write (0,*)' WARNING: iflag=+6 : ',iflag
       write (0,*)' requested accuracy was not achieved even'
       write (0,*)' with smallest allowable step-size; error'
       write (0,*)' tolerance specification must be increased'
       write (0,*)' relerr = ',relerr
       write (0,*)' abserr = ',abserr
       relerr = 10.d0*relerr
       write (0,*)' newly proposed RELATIVE ERROR : ',relerr
       iflout = iflin

      elseif (iflin.eq.7) then
       write (0,*)' WARNING: iflag=+7 : ',iflag
       write (0,*)' /rkf45/ is inefficient in solving  t h i s  problem'
       write (0,*)' (too much requested output is restricting the'
       write (0,*)'  optimal internal step-size choice);  use the'
       write (0,*)'  single-step integration mode:'
       iflag = -2
       write (0,*)' newly proposed iflag : ',iflag
       iflout = iflin

      elseif (iflin.eq.8) then
       write (0,*)' WARNING: iflag=+8 : ',iflag
       write (0,*)' invalid  i n p u t ;  likely causes:'
       write (0,*)   ' any of following is .true. :'
       write (0,*)' (t=tout .and. (iflag.ne.1.or.iflag.ne.-1) )'
       write (0,*)  ' (relerr.le.0 .or.   abserr.le.0)'
       write (0,*)' (iflag .eq.0,.or. .lt.-2, .or. gt.8d0)'
       iflout = 9

      else
        write (0,*)' rkf45 WARNING/ERROR flag : ',iflag,
     *        ' not understood'
        iflout = 9
      endif

      write (0,*)' STATUS: ',s,(u(i),i=1,neqn)

      if     (iflout.eq.4) then
         iflout = 2
         return
      elseif (iflout.eq.9) then
c         write (0,*)' THIS JOB BETTER TERMINATE !'
c     we can make this a little nicer crf
         write (0,*) ' this job should TERMINATE '
         return
      endif

c      write (0,*)' continue ?  [CR=yes]'
c      if (yes(1)) then
        iflout = 2
        if (iflin.eq.7) iflout = -2
c      else
c        iflout = 9
c        write (0,*)' thus : TERMINATE THIS JOB SEGMENT !'
c     trying to be nice again crf
c        write (0,*)' thus : THIS JOB SEGMENT TERMINATING'
c      endif

      return
      end





