
      real*8 function xprinc(x)
c     get "principal value" y(x) : x -> y, such that -pi < y < +pi

c     func/xprinc   status  : 10 February 1992

c     J. G. Dworski

c     H a n d l i n g :
c     -----------------
c     Use exemplified by computational "longitude", periodic with 2*pi,
c     with principal value [-pi,+pi].
c     Note: when input x is exactly +pi, output is exactly -pi, and
c           when input x is exactly -pi, output is exactly +pi.
c     INPUT :
c       x    [rad] =   real*8 angle, positive or negative reals
c     OUTPUT
c     xprinc [rad] =   real*8  angle, [-pi,+pi]


c     ------------------------------------------------------------
c     changes:
c       changed "double precision" to "real*8"  (craig friesen 7/8/92)
c     ------------------------------------------------------------
      real*8 x
      real*8 pi
      real*8 pi2
c      double precision xprinc

      parameter( pi=3.141592653589793d0,pi2=pi*2.d0 )
c     **********************************************
      xprinc = mod(x+pi,pi2) + pi*sign(1.d0,-(x+pi))
c     **********************************************
      return
      end

