
        logical function yes(mode)
c       interactive response interpretator

c       program status :   6 August 1984, 17:00

c       J. G Dworski

c       H a n d l i n g :
c       ===============
c       This routine is used to interpret the answer
c       to a QUALITATIVE question. The question is displayed
c       on the (terminal) screen, and the answer is entered
c       from the keyboard. One of the aims of the routine is
c       to protect program execution from inappropriate answers
c       that will be misunderstood by the running program.
c       This is accomplished by the logic associated with
c       parameters described below.

c       Valid answers are either WORDS or a CARRIAGE RETURN.
c (a)   any word that starts with a  "y" makes /yes/=.TRUE.
c (b)   any word that starts with an "n" makes /yes/=.FALSE.
c       (clearly, a single letter "y" or "n" suffices)
c (c)   A "carriage return", CR, is interpreted by /yes/
c       according to the INPUT ARGUMENT /mode/ :
c       if mode.eq. 1 then /yes/=.TRUE.
c       if mode.eq. 0 then /yes/=.FALSE.
c       if mode is any other alphanumerical symbol then the
c       answer is considered inapropriate.
c (d)   Inapropriate answers force an internal (w/in /yes/)
c       DEMAND for a clear and appropriate answer.

c       The calling program uses /yes/ in branching decisions
c       illustrated as follows :
c       if (yes(mode))      then
c       .....

c       NOTE also use of logical unit 9 instead of standard
c       input; in this way standard input can be diverted to
c       a file whose name comes from the command line.

c       -----------------------------------------------------

        character answer
        logical   opened

        data      opened/.false./,lu/9/

  500   format(' =>')
  510   format(' SORRY : response MUST be : y[es], or n[o], or CR.',
     1         ' Please answer AGAIN !',/
     2  ' (note also : h[elp] is not available for this question)')
  540   format(' * - * - * - * - * - * - * - * - * - * - * - * - * ')

  010   write (0,500)

        if (.not.opened) then
           OPEN(lu,file='/dev/tty')
           opened = .true.
        endif

        read(lu,'(a1)') answer
        if      (answer .eq. 'y') then
                 yes = .TRUE.
                 return
        else if (answer .eq. 'n') then
                 yes = .FALSE.
                 return
        else if (answer .eq. ' ') then
                     if (mode .eq. 1 ) then
                       yes = .TRUE.
                       return
                else if (mode .eq. 0 ) then
                       yes = .FALSE.
                       return
                     endif
        endif

        write(lu,540)
        write(lu,510)
        write(lu,540)
        go to 010
        end


